﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace Game131029
{
	static class Program
	{
		private static readonly Encoding shiftJisEncoding = Encoding.GetEncoding("Shift_JIS");

		public static Encoding ShiftJisEncoding
		{
			get
			{
				return shiftJisEncoding;
			}
		}
		public static string ExeDir { get; private set; }
		public static bool Record { get; set; }

		/// <summary>
		/// アプリケーションのメイン エントリ ポイントです。
		/// </summary>
		[STAThread]
		static void Main()
		{
			using (Mutex m = new Mutex(false, Application.ProductName))
			{
				if (m.WaitOne(0, false))
				{
					Application.EnableVisualStyles();
					Application.SetCompatibleTextRenderingDefault(false);
					using (Form1 f = new Form1())
					{
						ExeDir = Application.StartupPath;
#if DEBUG
						ExeDir = Directory.GetParent(Directory.GetParent(ExeDir).FullName).FullName;
#endif
						string scorePath = ExeDir + Path.DirectorySeparatorChar + "Score100.dat";
						Record = false;
						if (File.Exists(scorePath))
						{
							string[] lines = File.ReadAllLines(scorePath, shiftJisEncoding);
							List<Score> scoreList = new List<Score>();
							for (int i = 0, v; i < lines.Length; ++i)
							{
								string[] block = lines[i].Split(new string[] { "\t" }, StringSplitOptions.RemoveEmptyEntries);
								if (block.Length == 3 && int.TryParse(block[0], out v))
								{
									scoreList.Add(new Score(v, block[1], block[2]));
								}
							}
							f.SetScores(scoreList.ToArray());
						}
						Application.Run(f);
						if (Record)
						{
							Score[] scores = f.GetScores();
							StringBuilder sb = new StringBuilder(1024);
							for (int i = 0; i < scores.Length; ++i)
							{
								sb.Append(scores[i].Value.ToString());
								sb.Append("\t");
								sb.Append(scores[i].Name);
								sb.Append("\t");
								sb.Append(scores[i].Date);
								sb.Append(Environment.NewLine);
							}
							File.WriteAllText(scorePath, sb.ToString(), shiftJisEncoding);
						}
					}
				}
			}
		}
	}
}
