﻿using System;

namespace Game131029
{
	public struct Score
	{
		private readonly int value;
		private readonly string name;
		private readonly string date;
		private readonly string padding;

		public int Value
		{
			get
			{
				return this.value;
			}
		}
		public string Name
		{
			get
			{
				return this.name;
			}
		}
		public string Date
		{
			get
			{
				return this.date;
			}
		}

		public Score(int value, string name, string date)
		{
			this.value = value;
			this.name = name;
			this.date = date;
			this.padding = "{0,-" + (12 - (Program.ShiftJisEncoding.GetByteCount(this.name) - this.name.Length)).ToString() + "}";
		}

		public Score(int value, string name)
			: this(value, name, DateTime.Now.ToString())
		{
		}

		public string ToString(int num)
		{
			return string.Format("{0,2}", num) + string.Format("{0,9}", this.value) + " " + string.Format(this.padding, this.name) + " " + this.date;
		}
	}
}
